#!/bin/sh

# Default parameters
if [ $1 ];then
    IMG=$1;
else
    echo "\nYou must provide the raspberry pi image as first parameter\n";
    exit;
fi

if [ $2 ];then
    KERNEL=$2;
else
    KERNEL="rpi-20200922/kernel-qemu-5.4.51-buster"
fi

if [ $3 ];then
    DTB=$3;
else
    DTB="rpi-20200922/versatile-pb-buster-5.4.51.dtb"
fi

# Start qemu
qemu-system-arm \
    -kernel rpi-20200922/kernel-qemu-5.4.51-buster \
    -dtb rpi-20200922/versatile-pb-buster-5.4.51.dtb \
    -m 256 -M versatilepb -cpu arm1176 \
    -serial stdio \
    -append "rw console=ttyAMA0 root=/dev/vda2 panic=1 loglevel=8" \
    -drive "file=$IMG,if=none,index=0,media=disk,format=raw,id=disk0" \
    -device "virtio-blk-pci,drive=disk0,disable-modern=on,disable-legacy=off" \
    -no-reboot
